<template>
  <div>
    <v-layout row
      wrap
      v-bind="gridResponsiveness">
      <v-flex xs3>
        <v-select
          :items="intervalSelection"
          v-model.trim="selectedInterval"
          label="Select"
          single-line
          style="width:90%;margin:0 auto;">
        </v-select>
      </v-flex>
      <v-flex xs4 v-if="showDayPicker">
        <div style="width:90%;margin:0 auto;">
          <v-menu
            :close-on-content-click="false"
            v-model="menu2"
            :nudge-right="40"
            lazy
            transition="scale-transition"
            offset-y
            full-width
            max-width="290px"
            min-width="290px">
            <v-text-field
              slot="activator"
              v-model="date"
              label="Date"
              persistent-hint
              prepend-icon="event"
              readonly>
            </v-text-field>
            <v-date-picker
              v-model="date"
              no-title @input="menu2 = false">
            </v-date-picker>
          </v-menu>
        </div>
      </v-flex>
      <v-flex xs4
        v-if="showMonthPicker">
        <div style="width:90%;margin:0 auto;">
          <v-menu
            :close-on-content-click="false"
            v-model="menu2"
            :nudge-right="40"
            lazy
            transition="scale-transition"
            offset-y
            full-width
            max-width="290px"
            min-width="290px">
            <v-text-field
              slot="activator"
              v-model="formatedMonth"
              label="Date"
              persistent-hint
              prepend-icon="event"
              readonly>
            </v-text-field>
            <v-date-picker
              v-model="date"
              no-title @input="menu2 = false"
              type="month">
            </v-date-picker>
          </v-menu>
        </div>
      </v-flex>
      <v-flex xs4>
        <v-btn depressed
          block
          color="warning"
          style="width:90%;margin: 13px auto 13px auto;"
          @click="onShowReportClicked()">
            SHOW REPORT
        </v-btn>
      </v-flex>
    </v-layout>
  </div>
</template>
<script>
import moment from 'moment'
export default {
  name: 'QueryMenu',
  data: () => ({
    intervalSelection: ['Daily', 'Monthly'],
    selectedInterval: 'Daily',
    dateFormatted: null,
    menu1: false,
    date: moment(new Date()).format('YYYY-MM-DD'),
    menu2: false,
    showDayPicker: true,
    showMonthPicker: false,
    timeInterval: 'day'
  }),
  computed: {
    formatedMonth () {
      return moment(this.date).format('YYYY - MMMM')
    },
    gridResponsiveness () {
      const gridResponsiveness = {}
      if (this.$vuetify.breakpoint.sm || this.$vuetify.breakpoint.xs) gridResponsiveness.column = true
      return gridResponsiveness
    }
  },
  watch: {
    selectedInterval (val) {
      if (val === 'Daily') {
        this.showDayPicker = true
        this.showMonthPicker = false
        this.timeInterval = 'day'
      } else if (val === 'Monthly') {
        this.showDayPicker = false
        this.showMonthPicker = true
        this.timeInterval = 'month'
      }
    }
  },
  methods: {
    onShowReportClicked () {
      let startTime = moment(this.date).startOf(this.timeInterval).format('YYYY-MM-DDTHH:mm:ss.000') + 'Z'
      let endTime = moment(this.date).endOf(this.timeInterval).format('YYYY-MM-DDTHH:mm:ss.000') + 'Z'
      this.$store.dispatch('VIEW_ITEM_REQUEST', {startTime, endTime})
    }
  }
}
</script>
